/* Application.c generated by valac 0.56.17, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018-2021 Ryo Nakano <ryonakaknock3@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define GETTEXT_PACKAGE "com.github.ryonakano.reco"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
typedef struct _ApplicationPrivate ApplicationPrivate;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
enum  {
	APPLICATION_0_PROPERTY,
	APPLICATION_NUM_PROPERTIES
};
static GParamSpec* application_properties[APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Application {
	GtkApplication parent_instance;
	ApplicationPrivate * priv;
};

struct _ApplicationClass {
	GtkApplicationClass parent_class;
};

struct _ApplicationPrivate {
	MainWindow* window;
};

static gint Application_private_offset;
static gpointer application_parent_class = NULL;
VALA_EXTERN GSettings* application_settings;
GSettings* application_settings = NULL;

VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN Application* application_new (void);
VALA_EXTERN Application* application_construct (GType object_type);
static void application_real_activate (GApplication* base);
VALA_EXTERN MainWindow* main_window_new (Application* app);
VALA_EXTERN MainWindow* main_window_construct (GType object_type,
                                   Application* app);
static gint application_main (gchar** args,
                       gint args_length1);
static GObject * application_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void application_finalize (GObject * obj);
static GType application_get_type_once (void);

static inline gpointer
application_get_instance_private (Application* self)
{
	return G_STRUCT_MEMBER_P (self, Application_private_offset);
}

Application*
application_construct (GType object_type)
{
	Application * self = NULL;
	self = (Application*) g_object_new (object_type, "application-id", "com.github.ryonakano.reco", "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}

Application*
application_new (void)
{
	return application_construct (TYPE_APPLICATION);
}

static void
application_real_activate (GApplication* base)
{
	Application * self;
	MainWindow* _tmp0_;
	gint window_x = 0;
	gint window_y = 0;
	GSettings* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	MainWindow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	MainWindow* _tmp9_;
	self = (Application*) base;
	_tmp0_ = self->priv->window;
	if (_tmp0_ != NULL) {
		MainWindow* _tmp1_;
		_tmp1_ = self->priv->window;
		gtk_window_present ((GtkWindow*) _tmp1_);
		return;
	}
	_tmp2_ = application_settings;
	g_settings_get (_tmp2_, "window-position", "(ii)", &_tmp3_, &_tmp4_);
	window_x = _tmp3_;
	window_y = _tmp4_;
	_tmp5_ = main_window_new (self);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp5_;
	if (window_x != -1) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = window_y != -1;
	}
	if (_tmp6_) {
		MainWindow* _tmp7_;
		_tmp7_ = self->priv->window;
		gtk_window_move ((GtkWindow*) _tmp7_, window_x, window_y);
	} else {
		MainWindow* _tmp8_;
		_tmp8_ = self->priv->window;
		g_object_set ((GtkWindow*) _tmp8_, "window-position", GTK_WIN_POS_CENTER, NULL);
	}
	_tmp9_ = self->priv->window;
	gtk_widget_show_all ((GtkWidget*) _tmp9_);
}

static gint
application_main (gchar** args,
                  gint args_length1)
{
	Application* _tmp0_;
	Application* _tmp1_;
	gint _tmp2_;
	gint result;
	gst_init ((gint*) (&args_length1), &args);
	_tmp0_ = application_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return application_main (argv, argc);
}

static GObject *
application_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Application * self;
	parent_class = G_OBJECT_CLASS (application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	return obj;
}

static void
application_class_init (ApplicationClass * klass,
                        gpointer klass_data)
{
	GSettings* _tmp0_;
	application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Application_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) application_real_activate;
	G_OBJECT_CLASS (klass)->constructor = application_constructor;
	G_OBJECT_CLASS (klass)->finalize = application_finalize;
	_tmp0_ = g_settings_new ("com.github.ryonakano.reco");
	_g_object_unref0 (application_settings);
	application_settings = _tmp0_;
}

static void
application_instance_init (Application * self,
                           gpointer klass)
{
	self->priv = application_get_instance_private (self);
}

static void
application_finalize (GObject * obj)
{
	Application * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (application_parent_class)->finalize (obj);
}

static GType
application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Application), 0, (GInstanceInitFunc) application_instance_init, NULL };
	GType application_type_id;
	application_type_id = g_type_register_static (gtk_application_get_type (), "Application", &g_define_type_info, 0);
	Application_private_offset = g_type_add_instance_private (application_type_id, sizeof (ApplicationPrivate));
	return application_type_id;
}

GType
application_get_type (void)
{
	static volatile gsize application_type_id__once = 0;
	if (g_once_init_enter (&application_type_id__once)) {
		GType application_type_id;
		application_type_id = application_get_type_once ();
		g_once_init_leave (&application_type_id__once, application_type_id);
	}
	return application_type_id__once;
}

