/* PulseAudioManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018-2021 Ryo Nakano <ryonakaknock3@gmail.com>
 *
 * Code brought from elementary/switchboard-plug-sound, src/PulseAudioManager.vala, authored by Corentin Noël
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PULSE_AUDIO_MANAGER (pulse_audio_manager_get_type ())
#define PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManager))
#define PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManagerClass))
#define IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PULSE_AUDIO_MANAGER))
#define IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PULSE_AUDIO_MANAGER))
#define PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManagerClass))

typedef struct _PulseAudioManager PulseAudioManager;
typedef struct _PulseAudioManagerClass PulseAudioManagerClass;
typedef struct _PulseAudioManagerPrivate PulseAudioManagerPrivate;
enum  {
	PULSE_AUDIO_MANAGER_0_PROPERTY,
	PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY,
	PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY,
	PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* pulse_audio_manager_properties[PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _PulseAudioManagerReconnectToPulseData PulseAudioManagerReconnectToPulseData;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))

struct _PulseAudioManager {
	GObject parent_instance;
	PulseAudioManagerPrivate * priv;
};

struct _PulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _PulseAudioManagerPrivate {
	gchar* _default_source_name;
	gchar* _default_sink_name;
	pa_context* context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
};

struct _PulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	const gchar* _tmp10_;
};

static gint PulseAudioManager_private_offset;
static gpointer pulse_audio_manager_parent_class = NULL;
static PulseAudioManager* pulse_audio_manager_pam;
static PulseAudioManager* pulse_audio_manager_pam = NULL;

VALA_EXTERN GType pulse_audio_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PulseAudioManager, g_object_unref)
VALA_EXTERN PulseAudioManager* pulse_audio_manager_get_default (void);
static PulseAudioManager* pulse_audio_manager_new (void);
static PulseAudioManager* pulse_audio_manager_construct (GType object_type);
VALA_EXTERN void pulse_audio_manager_start (PulseAudioManager* self);
static void pulse_audio_manager_reconnect_to_pulse (PulseAudioManager* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void pulse_audio_manager_reconnect_to_pulse_finish (PulseAudioManager* self,
                                                    GAsyncResult* _res_);
static gboolean pulse_audio_manager_reconnect_timeout (PulseAudioManager* self);
static void pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static gboolean pulse_audio_manager_reconnect_to_pulse_co (PulseAudioManagerReconnectToPulseData* _data_);
static void pulse_audio_manager_context_state_callback (PulseAudioManager* self,
                                                 pa_context* c);
static void _pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                         gpointer self);
static void pulse_audio_manager_subscribe_callback (PulseAudioManager* self,
                                             pa_context* c,
                                             pa_subscription_event_type_t t,
                                             guint32 index);
static void _pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                        pa_subscription_event_type_t t,
                                                                        guint32 idx,
                                                                        gpointer self);
static void pulse_audio_manager_server_info_callback (PulseAudioManager* self,
                                               pa_context* context,
                                               pa_server_info* server);
static void _pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                    pa_server_info* i,
                                                                    gpointer self);
static gboolean _pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
VALA_EXTERN const gchar* pulse_audio_manager_get_default_sink_name (PulseAudioManager* self);
static void pulse_audio_manager_set_default_sink_name (PulseAudioManager* self,
                                                const gchar* value);
VALA_EXTERN const gchar* pulse_audio_manager_get_default_source_name (PulseAudioManager* self);
static void pulse_audio_manager_set_default_source_name (PulseAudioManager* self,
                                                  const gchar* value);
static void pulse_audio_manager_finalize (GObject * obj);
static GType pulse_audio_manager_get_type_once (void);
static void _vala_pulse_audio_manager_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_pulse_audio_manager_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
pulse_audio_manager_get_instance_private (PulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, PulseAudioManager_private_offset);
}

PulseAudioManager*
pulse_audio_manager_get_default (void)
{
	PulseAudioManager* _tmp0_;
	PulseAudioManager* _tmp2_;
	PulseAudioManager* result;
	_tmp0_ = pulse_audio_manager_pam;
	if (_tmp0_ == NULL) {
		PulseAudioManager* _tmp1_;
		_tmp1_ = pulse_audio_manager_new ();
		_g_object_unref0 (pulse_audio_manager_pam);
		pulse_audio_manager_pam = _tmp1_;
	}
	_tmp2_ = pulse_audio_manager_pam;
	result = _tmp2_;
	return result;
}

static PulseAudioManager*
pulse_audio_manager_construct (GType object_type)
{
	PulseAudioManager * self = NULL;
	pa_glib_mainloop* _tmp0_;
	self = (PulseAudioManager*) g_object_new (object_type, NULL);
	_tmp0_ = pa_glib_mainloop_new (NULL);
	_pa_glib_mainloop_free0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	return self;
}

static PulseAudioManager*
pulse_audio_manager_new (void)
{
	return pulse_audio_manager_construct (TYPE_PULSE_AUDIO_MANAGER);
}

void
pulse_audio_manager_start (PulseAudioManager* self)
{
	g_return_if_fail (self != NULL);
	pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
}

static gboolean
pulse_audio_manager_reconnect_timeout (PulseAudioManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->reconnect_timer_id = 0U;
	pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
	result = FALSE;
	return result;
}

static void
pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	PulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PulseAudioManagerReconnectToPulseData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
pulse_audio_manager_reconnect_to_pulse (PulseAudioManager* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	PulseAudioManagerReconnectToPulseData* _data_;
	PulseAudioManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (PulseAudioManagerReconnectToPulseData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, pulse_audio_manager_reconnect_to_pulse_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	pulse_audio_manager_reconnect_to_pulse_co (_data_);
}

static void
pulse_audio_manager_reconnect_to_pulse_finish (PulseAudioManager* self,
                                               GAsyncResult* _res_)
{
	PulseAudioManagerReconnectToPulseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                    gpointer self)
{
	pulse_audio_manager_context_state_callback ((PulseAudioManager*) self, c);
}

static gboolean
pulse_audio_manager_reconnect_to_pulse_co (PulseAudioManagerReconnectToPulseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->self->priv->is_ready) {
		_data_->_tmp0_ = _data_->self->priv->context;
		pa_context_disconnect (_data_->_tmp0_);
		_pa_context_unref0 (_data_->self->priv->context);
		_data_->self->priv->context = NULL;
		_data_->self->priv->is_ready = FALSE;
	}
	_data_->_tmp1_ = pa_proplist_new ();
	_data_->props = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->props;
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "com.github.ryonakano.reco");
	_data_->_tmp3_ = _data_->self->priv->loop;
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
	_data_->_tmp5_ = _data_->props;
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
	_pa_context_unref0 (_data_->self->priv->context);
	_data_->self->priv->context = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->self->priv->context;
	pa_context_set_state_callback (_data_->_tmp7_, _pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
	_data_->_tmp8_ = _data_->self->priv->context;
	if (pa_context_connect (_data_->_tmp8_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
		_data_->_tmp9_ = _data_->self->priv->context;
		_data_->_tmp10_ = pa_strerror (pa_context_errno (_data_->_tmp9_));
		g_warning ("PulseAudioManager.vala:53: pa_context_connect () failed: %s", _data_->_tmp10_);
	}
	_pa_proplist_free0 (_data_->props);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                   pa_subscription_event_type_t t,
                                                                   guint32 idx,
                                                                   gpointer self)
{
	pulse_audio_manager_subscribe_callback ((PulseAudioManager*) self, c, t, idx);
}

static void
_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                               pa_server_info* i,
                                                               gpointer self)
{
	pulse_audio_manager_server_info_callback ((PulseAudioManager*) self, c, i);
}

static gboolean
_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = pulse_audio_manager_reconnect_timeout ((PulseAudioManager*) self);
	return result;
}

static void
pulse_audio_manager_context_state_callback (PulseAudioManager* self,
                                            pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
			pa_context_set_subscribe_callback (c, _pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
			_tmp0_ = pa_context_subscribe (c, PA_SUBSCRIPTION_MASK_SERVER, NULL, NULL);
			_tmp1_ = _tmp0_;
			_pa_operation_unref0 (_tmp1_);
			_tmp2_ = self->priv->context;
			_tmp3_ = pa_context_get_server_info (_tmp2_, _pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp4_ = _tmp3_;
			_pa_operation_unref0 (_tmp4_);
			self->priv->is_ready = TRUE;
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			if (self->priv->reconnect_timer_id == 0U) {
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
			}
			break;
		}
		default:
		{
			self->priv->is_ready = FALSE;
			break;
		}
	}
}

static void
pulse_audio_manager_subscribe_callback (PulseAudioManager* self,
                                        pa_context* c,
                                        pa_subscription_event_type_t t,
                                        guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
	if (source_type == PA_SUBSCRIPTION_EVENT_SERVER) {
		pa_context* _tmp0_;
		pa_operation* _tmp1_;
		pa_operation* _tmp2_;
		_tmp0_ = self->priv->context;
		_tmp1_ = pa_context_get_server_info (_tmp0_, _pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
		_tmp2_ = _tmp1_;
		_pa_operation_unref0 (_tmp2_);
	}
}

static void
pulse_audio_manager_server_info_callback (PulseAudioManager* self,
                                          pa_context* context,
                                          pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp8_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	if (server == NULL) {
		return;
	}
	_tmp0_ = self->priv->_default_sink_name;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = (*server).default_sink_name;
		pulse_audio_manager_set_default_sink_name (self, _tmp1_);
		_tmp2_ = self->priv->_default_sink_name;
		g_debug ("PulseAudioManager.vala:92: Detected default sink: %s", _tmp2_);
	}
	_tmp3_ = self->priv->_default_sink_name;
	_tmp4_ = (*server).default_sink_name;
	if (g_strcmp0 (_tmp3_, _tmp4_) != 0) {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp5_ = self->priv->_default_sink_name;
		_tmp6_ = (*server).default_sink_name;
		g_debug ("PulseAudioManager.vala:96: Detected default sink changed: %s > %s", _tmp5_, _tmp6_);
		_tmp7_ = (*server).default_sink_name;
		pulse_audio_manager_set_default_sink_name (self, _tmp7_);
	}
	_tmp8_ = self->priv->_default_source_name;
	if (_tmp8_ == NULL) {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = (*server).default_source_name;
		pulse_audio_manager_set_default_source_name (self, _tmp9_);
		_tmp10_ = self->priv->_default_source_name;
		g_debug ("PulseAudioManager.vala:102: Detected default source: %s", _tmp10_);
	}
	_tmp11_ = self->priv->_default_source_name;
	_tmp12_ = (*server).default_source_name;
	if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp13_ = self->priv->_default_source_name;
		_tmp14_ = (*server).default_source_name;
		g_debug ("PulseAudioManager.vala:106: Detected default source changed: %s > %s", _tmp13_, _tmp14_);
		_tmp15_ = (*server).default_source_name;
		pulse_audio_manager_set_default_source_name (self, _tmp15_);
	}
}

const gchar*
pulse_audio_manager_get_default_source_name (PulseAudioManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_source_name;
	result = _tmp0_;
	return result;
}

static void
pulse_audio_manager_set_default_source_name (PulseAudioManager* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = pulse_audio_manager_get_default_source_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_default_source_name);
		self->priv->_default_source_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pulse_audio_manager_properties[PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY]);
	}
}

const gchar*
pulse_audio_manager_get_default_sink_name (PulseAudioManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_sink_name;
	result = _tmp0_;
	return result;
}

static void
pulse_audio_manager_set_default_sink_name (PulseAudioManager* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = pulse_audio_manager_get_default_sink_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_default_sink_name);
		self->priv->_default_sink_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pulse_audio_manager_properties[PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY]);
	}
}

static void
pulse_audio_manager_class_init (PulseAudioManagerClass * klass,
                                gpointer klass_data)
{
	pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PulseAudioManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pulse_audio_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pulse_audio_manager_set_property;
	G_OBJECT_CLASS (klass)->finalize = pulse_audio_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY, pulse_audio_manager_properties[PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY] = g_param_spec_string ("default-source-name", "default-source-name", "default-source-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY, pulse_audio_manager_properties[PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY] = g_param_spec_string ("default-sink-name", "default-sink-name", "default-sink-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
pulse_audio_manager_instance_init (PulseAudioManager * self,
                                   gpointer klass)
{
	self->priv = pulse_audio_manager_get_instance_private (self);
	self->priv->is_ready = FALSE;
	self->priv->reconnect_timer_id = 0U;
}

static void
pulse_audio_manager_finalize (GObject * obj)
{
	PulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PULSE_AUDIO_MANAGER, PulseAudioManager);
	_g_free0 (self->priv->_default_source_name);
	_g_free0 (self->priv->_default_sink_name);
	_pa_context_unref0 (self->priv->context);
	_pa_glib_mainloop_free0 (self->priv->loop);
	G_OBJECT_CLASS (pulse_audio_manager_parent_class)->finalize (obj);
}

static GType
pulse_audio_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PulseAudioManager), 0, (GInstanceInitFunc) pulse_audio_manager_instance_init, NULL };
	GType pulse_audio_manager_type_id;
	pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PulseAudioManager", &g_define_type_info, 0);
	PulseAudioManager_private_offset = g_type_add_instance_private (pulse_audio_manager_type_id, sizeof (PulseAudioManagerPrivate));
	return pulse_audio_manager_type_id;
}

GType
pulse_audio_manager_get_type (void)
{
	static volatile gsize pulse_audio_manager_type_id__once = 0;
	if (g_once_init_enter (&pulse_audio_manager_type_id__once)) {
		GType pulse_audio_manager_type_id;
		pulse_audio_manager_type_id = pulse_audio_manager_get_type_once ();
		g_once_init_leave (&pulse_audio_manager_type_id__once, pulse_audio_manager_type_id);
	}
	return pulse_audio_manager_type_id__once;
}

static void
_vala_pulse_audio_manager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PULSE_AUDIO_MANAGER, PulseAudioManager);
	switch (property_id) {
		case PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY:
		g_value_set_string (value, pulse_audio_manager_get_default_source_name (self));
		break;
		case PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY:
		g_value_set_string (value, pulse_audio_manager_get_default_sink_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pulse_audio_manager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PULSE_AUDIO_MANAGER, PulseAudioManager);
	switch (property_id) {
		case PULSE_AUDIO_MANAGER_DEFAULT_SOURCE_NAME_PROPERTY:
		pulse_audio_manager_set_default_source_name (self, g_value_get_string (value));
		break;
		case PULSE_AUDIO_MANAGER_DEFAULT_SINK_NAME_PROPERTY:
		pulse_audio_manager_set_default_sink_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

