/* Recorder.c generated by valac 0.56.17, the Vala compiler
 * generated from Recorder.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018-2021 Ryo Nakano <ryonakaknock3@gmail.com>
 *
 * GStreamer related codes are inspired from artemanufrij/screencast, src/MainWindow.vala
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_RECORDER (recorder_get_type ())
#define RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RECORDER, Recorder))
#define RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RECORDER, RecorderClass))
#define IS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RECORDER))
#define IS_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RECORDER))
#define RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RECORDER, RecorderClass))

typedef struct _Recorder Recorder;
typedef struct _RecorderClass RecorderClass;
typedef struct _RecorderPrivate RecorderPrivate;

#define TYPE_PULSE_AUDIO_MANAGER (pulse_audio_manager_get_type ())
#define PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManager))
#define PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManagerClass))
#define IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PULSE_AUDIO_MANAGER))
#define IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PULSE_AUDIO_MANAGER))
#define PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PULSE_AUDIO_MANAGER, PulseAudioManagerClass))

typedef struct _PulseAudioManager PulseAudioManager;
typedef struct _PulseAudioManagerClass PulseAudioManagerClass;
enum  {
	RECORDER_0_PROPERTY,
	RECORDER_IS_RECORDING_PROPERTY,
	RECORDER_NUM_PROPERTIES
};
static GParamSpec* recorder_properties[RECORDER_NUM_PROPERTIES];
typedef enum  {
	RECORDER_SOURCE_MIC,
	RECORDER_SOURCE_SYSTEM,
	RECORDER_SOURCE_BOTH
} RecorderSource;

#define RECORDER_TYPE_SOURCE (recorder_source_get_type ())
typedef enum  {
	RECORDER_CHANNELS_MONO = 1,
	RECORDER_CHANNELS_STEREO = 2
} RecorderChannels;

#define RECORDER_TYPE_CHANNELS (recorder_channels_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	RECORDER_THROW_ERROR_SIGNAL,
	RECORDER_SAVE_FILE_SIGNAL,
	RECORDER_NUM_SIGNALS
};
static guint recorder_signals[RECORDER_NUM_SIGNALS] = {0};

struct _Recorder {
	GObject parent_instance;
	RecorderPrivate * priv;
};

struct _RecorderClass {
	GObjectClass parent_class;
};

struct _RecorderPrivate {
	gboolean _is_recording;
	PulseAudioManager* pam;
	gchar* suffix;
	gchar* tmp_full_path;
	GstPipeline* pipeline;
	guint inhibit_token;
};

static gint Recorder_private_offset;
static gpointer recorder_parent_class = NULL;
static Recorder* recorder__instance;
static Recorder* recorder__instance = NULL;
VALA_EXTERN GSettings* application_settings;

VALA_EXTERN GType recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Recorder, g_object_unref)
VALA_EXTERN GType pulse_audio_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PulseAudioManager, g_object_unref)
static GType recorder_source_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType recorder_channels_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN Recorder* recorder_get_default (void);
static Recorder* recorder_new (void);
static Recorder* recorder_construct (GType object_type);
VALA_EXTERN PulseAudioManager* pulse_audio_manager_get_default (void);
VALA_EXTERN void pulse_audio_manager_start (PulseAudioManager* self);
VALA_EXTERN void recorder_start_recording (Recorder* self,
                               GError** error);
VALA_EXTERN const gchar* pulse_audio_manager_get_default_sink_name (PulseAudioManager* self);
VALA_EXTERN const gchar* pulse_audio_manager_get_default_source_name (PulseAudioManager* self);
static gboolean recorder_bus_message_cb (Recorder* self,
                                  GstBus* bus,
                                  GstMessage* msg);
static gboolean _recorder_bus_message_cb_gst_bus_func (GstBus* bus,
                                                GstMessage* message,
                                                gpointer self);
VALA_EXTERN void recorder_set_recording_state (Recorder* self,
                                   GstState state);
static void recorder_inhibit_sleep (Recorder* self);
VALA_EXTERN void recorder_cancel_recording (Recorder* self);
static void recorder_uninhibit_sleep (Recorder* self);
VALA_EXTERN void recorder_stop_recording (Recorder* self);
static void recorder_set_is_recording (Recorder* self,
                                gboolean value);
VALA_EXTERN gboolean recorder_get_is_recording (Recorder* self);
static void g_cclosure_user_marshal_VOID__BOXED_STRING (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void recorder_finalize (GObject * obj);
static GType recorder_get_type_once (void);
static void _vala_recorder_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_recorder_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

static inline gpointer
recorder_get_instance_private (Recorder* self)
{
	return G_STRUCT_MEMBER_P (self, Recorder_private_offset);
}

static GType
recorder_source_get_type_once (void)
{
	static const GEnumValue values[] = {{RECORDER_SOURCE_MIC, "RECORDER_SOURCE_MIC", "mic"}, {RECORDER_SOURCE_SYSTEM, "RECORDER_SOURCE_SYSTEM", "system"}, {RECORDER_SOURCE_BOTH, "RECORDER_SOURCE_BOTH", "both"}, {0, NULL, NULL}};
	GType recorder_source_type_id;
	recorder_source_type_id = g_enum_register_static ("RecorderSource", values);
	return recorder_source_type_id;
}

static GType
recorder_source_get_type (void)
{
	static volatile gsize recorder_source_type_id__once = 0;
	if (g_once_init_enter (&recorder_source_type_id__once)) {
		GType recorder_source_type_id;
		recorder_source_type_id = recorder_source_get_type_once ();
		g_once_init_leave (&recorder_source_type_id__once, recorder_source_type_id);
	}
	return recorder_source_type_id__once;
}

static GType
recorder_channels_get_type_once (void)
{
	static const GEnumValue values[] = {{RECORDER_CHANNELS_MONO, "RECORDER_CHANNELS_MONO", "mono"}, {RECORDER_CHANNELS_STEREO, "RECORDER_CHANNELS_STEREO", "stereo"}, {0, NULL, NULL}};
	GType recorder_channels_type_id;
	recorder_channels_type_id = g_enum_register_static ("RecorderChannels", values);
	return recorder_channels_type_id;
}

static GType
recorder_channels_get_type (void)
{
	static volatile gsize recorder_channels_type_id__once = 0;
	if (g_once_init_enter (&recorder_channels_type_id__once)) {
		GType recorder_channels_type_id;
		recorder_channels_type_id = recorder_channels_get_type_once ();
		g_once_init_leave (&recorder_channels_type_id__once, recorder_channels_type_id);
	}
	return recorder_channels_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

Recorder*
recorder_get_default (void)
{
	Recorder* _tmp0_;
	Recorder* _tmp2_;
	Recorder* _tmp3_;
	Recorder* result;
	_tmp0_ = recorder__instance;
	if (_tmp0_ == NULL) {
		Recorder* _tmp1_;
		_tmp1_ = recorder_new ();
		_g_object_unref0 (recorder__instance);
		recorder__instance = _tmp1_;
	}
	_tmp2_ = recorder__instance;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static Recorder*
recorder_construct (GType object_type)
{
	Recorder * self = NULL;
	PulseAudioManager* _tmp0_;
	PulseAudioManager* _tmp1_;
	PulseAudioManager* _tmp2_;
	self = (Recorder*) g_object_new (object_type, NULL);
	_tmp0_ = pulse_audio_manager_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->pam);
	self->priv->pam = _tmp1_;
	_tmp2_ = self->priv->pam;
	pulse_audio_manager_start (_tmp2_);
	return self;
}

static Recorder*
recorder_new (void)
{
	return recorder_construct (TYPE_RECORDER);
}

static gboolean
_recorder_bus_message_cb_gst_bus_func (GstBus* bus,
                                       GstMessage* message,
                                       gpointer self)
{
	gboolean result;
	result = recorder_bus_message_cb ((Recorder*) self, bus, message);
	return result;
}

void
recorder_start_recording (Recorder* self,
                          GError** error)
{
	GstPipeline* _tmp0_;
	GstElement* sink = NULL;
	GstElement* _tmp1_;
	GstPipeline* _tmp2_;
	RecorderSource source = 0;
	GSettings* _tmp6_;
	GstElement* sys_sound = NULL;
	GstElement* mic_sound = NULL;
	GstElement* encoder = NULL;
	GstElement* muxer = NULL;
	gchar* file_format = NULL;
	GSettings* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	GQuark _tmp32_ = 0U;
	static GQuark _tmp31_label0 = 0;
	static GQuark _tmp31_label1 = 0;
	static GQuark _tmp31_label2 = 0;
	static GQuark _tmp31_label3 = 0;
	static GQuark _tmp31_label4 = 0;
	GstElement* _tmp48_;
	gchar* tmp_filename = NULL;
	GDateTime* _tmp50_;
	GDateTime* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GstElement* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	GstElement* caps_filter = NULL;
	GstElement* _tmp65_;
	GstElement* _tmp66_;
	GSettings* _tmp67_;
	GstCaps* _tmp68_;
	GstCaps* _tmp69_;
	GstPipeline* _tmp70_;
	GstElement* _tmp71_;
	GstElement* _tmp72_;
	GstElement* _tmp73_;
	GstElement* _tmp104_;
	GstPipeline* _tmp117_;
	GstBus* _tmp118_;
	GstBus* _tmp119_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->pipeline);
	self->priv->pipeline = _tmp0_;
	_tmp1_ = gst_element_factory_make ("filesink", "sink");
	if (_tmp1_ != NULL) {
		g_object_ref_sink (_tmp1_);
	}
	sink = _tmp1_;
	_tmp2_ = self->priv->pipeline;
	if (_tmp2_ == NULL) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (GST_PARSE_ERROR, GST_PARSE_ERROR_NO_SUCH_ELEMENT, "Failed to create the GStreamer element \"pipeline\"");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == GST_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (sink);
			return;
		} else {
			_g_object_unref0 (sink);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	} else {
		GstElement* _tmp4_;
		_tmp4_ = sink;
		if (_tmp4_ == NULL) {
			GError* _tmp5_;
			_tmp5_ = g_error_new_literal (GST_PARSE_ERROR, GST_PARSE_ERROR_NO_SUCH_ELEMENT, "Failed to create the GStreamer element \"filesink\"");
			_inner_error0_ = _tmp5_;
			if (_inner_error0_->domain == GST_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (sink);
				return;
			} else {
				_g_object_unref0 (sink);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp6_ = application_settings;
	source = (RecorderSource) g_settings_get_enum (_tmp6_, "source");
	sys_sound = NULL;
	if (source != RECORDER_SOURCE_MIC) {
		GstElement* _tmp7_;
		GstElement* _tmp8_;
		gchar* default_monitor = NULL;
		PulseAudioManager* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GstElement* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp7_ = gst_element_factory_make ("pulsesrc", "sys_sound");
		if (_tmp7_ != NULL) {
			g_object_ref_sink (_tmp7_);
		}
		_g_object_unref0 (sys_sound);
		sys_sound = _tmp7_;
		_tmp8_ = sys_sound;
		if (_tmp8_ == NULL) {
			GError* _tmp9_;
			_tmp9_ = g_error_new_literal (GST_PARSE_ERROR, GST_PARSE_ERROR_NO_SUCH_ELEMENT, "Failed to create the GStreamer pulsesrc element \"sys_sound\"");
			_inner_error0_ = _tmp9_;
			if (_inner_error0_->domain == GST_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (sys_sound);
				_g_object_unref0 (sink);
				return;
			} else {
				_g_object_unref0 (sys_sound);
				_g_object_unref0 (sink);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp10_ = self->priv->pam;
		_tmp11_ = pulse_audio_manager_get_default_sink_name (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat (_tmp12_, ".monitor", NULL);
		default_monitor = _tmp13_;
		_tmp14_ = sys_sound;
		_tmp15_ = default_monitor;
		g_object_set ((GObject*) _tmp14_, "device", _tmp15_, NULL);
		_tmp16_ = default_monitor;
		g_debug ("Recorder.vala:66: Set system sound source device to \"%s\"", _tmp16_);
		_g_free0 (default_monitor);
	}
	mic_sound = NULL;
	if (source != RECORDER_SOURCE_SYSTEM) {
		GstElement* _tmp17_;
		GstElement* _tmp18_;
		GstElement* _tmp20_;
		PulseAudioManager* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		PulseAudioManager* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		_tmp17_ = gst_element_factory_make ("pulsesrc", "mic_sound");
		if (_tmp17_ != NULL) {
			g_object_ref_sink (_tmp17_);
		}
		_g_object_unref0 (mic_sound);
		mic_sound = _tmp17_;
		_tmp18_ = mic_sound;
		if (_tmp18_ == NULL) {
			GError* _tmp19_;
			_tmp19_ = g_error_new_literal (GST_PARSE_ERROR, GST_PARSE_ERROR_NO_SUCH_ELEMENT, "Failed to create the GStreamer pulsesrc element \"mic_sound\"");
			_inner_error0_ = _tmp19_;
			if (_inner_error0_->domain == GST_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (mic_sound);
				_g_object_unref0 (sys_sound);
				_g_object_unref0 (sink);
				return;
			} else {
				_g_object_unref0 (mic_sound);
				_g_object_unref0 (sys_sound);
				_g_object_unref0 (sink);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp20_ = mic_sound;
		_tmp21_ = self->priv->pam;
		_tmp22_ = pulse_audio_manager_get_default_source_name (_tmp21_);
		_tmp23_ = _tmp22_;
		g_object_set ((GObject*) _tmp20_, "device", _tmp23_, NULL);
		_tmp24_ = self->priv->pam;
		_tmp25_ = pulse_audio_manager_get_default_source_name (_tmp24_);
		_tmp26_ = _tmp25_;
		g_debug ("Recorder.vala:77: Set source microphone to \"%s\"", _tmp26_);
	}
	muxer = NULL;
	_tmp27_ = application_settings;
	_tmp28_ = g_settings_get_string (_tmp27_, "format");
	file_format = _tmp28_;
	_tmp29_ = file_format;
	_tmp30_ = _tmp29_;
	_tmp32_ = (NULL == _tmp30_) ? 0 : g_quark_from_string (_tmp30_);
	if (_tmp32_ == ((0 != _tmp31_label0) ? _tmp31_label0 : (_tmp31_label0 = g_quark_from_static_string ("alac")))) {
		switch (0) {
			default:
			{
				GstElement* _tmp33_;
				GstElement* _tmp34_;
				gchar* _tmp35_;
				_tmp33_ = gst_element_factory_make ("avenc_alac", "encoder");
				if (_tmp33_ != NULL) {
					g_object_ref_sink (_tmp33_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp33_;
				_tmp34_ = gst_element_factory_make ("mp4mux", "muxer");
				if (_tmp34_ != NULL) {
					g_object_ref_sink (_tmp34_);
				}
				_g_object_unref0 (muxer);
				muxer = _tmp34_;
				_tmp35_ = g_strdup (".m4a");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp35_;
				break;
			}
		}
	} else if (_tmp32_ == ((0 != _tmp31_label1) ? _tmp31_label1 : (_tmp31_label1 = g_quark_from_static_string ("flac")))) {
		switch (0) {
			default:
			{
				GstElement* _tmp36_;
				gchar* _tmp37_;
				_tmp36_ = gst_element_factory_make ("flacenc", "encoder");
				if (_tmp36_ != NULL) {
					g_object_ref_sink (_tmp36_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp36_;
				_tmp37_ = g_strdup (".flac");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp37_;
				break;
			}
		}
	} else if (_tmp32_ == ((0 != _tmp31_label2) ? _tmp31_label2 : (_tmp31_label2 = g_quark_from_static_string ("mp3")))) {
		switch (0) {
			default:
			{
				GstElement* _tmp38_;
				gchar* _tmp39_;
				_tmp38_ = gst_element_factory_make ("lamemp3enc", "encoder");
				if (_tmp38_ != NULL) {
					g_object_ref_sink (_tmp38_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp38_;
				_tmp39_ = g_strdup (".mp3");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp39_;
				break;
			}
		}
	} else if (_tmp32_ == ((0 != _tmp31_label3) ? _tmp31_label3 : (_tmp31_label3 = g_quark_from_static_string ("ogg")))) {
		switch (0) {
			default:
			{
				GstElement* _tmp40_;
				GstElement* _tmp41_;
				gchar* _tmp42_;
				_tmp40_ = gst_element_factory_make ("vorbisenc", "encoder");
				if (_tmp40_ != NULL) {
					g_object_ref_sink (_tmp40_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp40_;
				_tmp41_ = gst_element_factory_make ("oggmux", "muxer");
				if (_tmp41_ != NULL) {
					g_object_ref_sink (_tmp41_);
				}
				_g_object_unref0 (muxer);
				muxer = _tmp41_;
				_tmp42_ = g_strdup (".ogg");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp42_;
				break;
			}
		}
	} else if (_tmp32_ == ((0 != _tmp31_label4) ? _tmp31_label4 : (_tmp31_label4 = g_quark_from_static_string ("opus")))) {
		switch (0) {
			default:
			{
				GstElement* _tmp43_;
				GstElement* _tmp44_;
				gchar* _tmp45_;
				_tmp43_ = gst_element_factory_make ("opusenc", "encoder");
				if (_tmp43_ != NULL) {
					g_object_ref_sink (_tmp43_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp43_;
				_tmp44_ = gst_element_factory_make ("oggmux", "muxer");
				if (_tmp44_ != NULL) {
					g_object_ref_sink (_tmp44_);
				}
				_g_object_unref0 (muxer);
				muxer = _tmp44_;
				_tmp45_ = g_strdup (".opus");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp45_;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GstElement* _tmp46_;
				gchar* _tmp47_;
				_tmp46_ = gst_element_factory_make ("wavenc", "encoder");
				if (_tmp46_ != NULL) {
					g_object_ref_sink (_tmp46_);
				}
				_g_object_unref0 (encoder);
				encoder = _tmp46_;
				_tmp47_ = g_strdup (".wav");
				_g_free0 (self->priv->suffix);
				self->priv->suffix = _tmp47_;
				break;
			}
		}
	}
	_tmp48_ = encoder;
	if (_tmp48_ == NULL) {
		GError* _tmp49_;
		_tmp49_ = g_error_new_literal (GST_PARSE_ERROR, GST_PARSE_ERROR_NO_SUCH_ELEMENT, "Failed to create the GStreamer element \"encoder\"");
		_inner_error0_ = _tmp49_;
		if (_inner_error0_->domain == GST_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (file_format);
			_g_object_unref0 (muxer);
			_g_object_unref0 (encoder);
			_g_object_unref0 (mic_sound);
			_g_object_unref0 (sys_sound);
			_g_object_unref0 (sink);
			return;
		} else {
			_g_free0 (file_format);
			_g_object_unref0 (muxer);
			_g_object_unref0 (encoder);
			_g_object_unref0 (mic_sound);
			_g_object_unref0 (sys_sound);
			_g_object_unref0 (sink);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp50_ = g_date_time_new_now_local ();
	_tmp51_ = _tmp50_;
	_tmp52_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_date_time_to_unix (_tmp51_));
	_tmp53_ = _tmp52_;
	_tmp54_ = g_strconcat ("reco_", _tmp53_, NULL);
	_tmp55_ = _tmp54_;
	_g_free0 (_tmp53_);
	_g_date_time_unref0 (_tmp51_);
	tmp_filename = _tmp55_;
	_tmp56_ = g_get_user_cache_dir ();
	_tmp57_ = tmp_filename;
	_tmp58_ = self->priv->suffix;
	_tmp59_ = g_strdup_printf ("/%s%s", _tmp57_, _tmp58_);
	_tmp60_ = _tmp59_;
	_tmp61_ = g_strconcat (_tmp56_, _tmp60_, NULL);
	_g_free0 (self->priv->tmp_full_path);
	self->priv->tmp_full_path = _tmp61_;
	_g_free0 (_tmp60_);
	_tmp62_ = sink;
	_tmp63_ = self->priv->tmp_full_path;
	g_object_set ((GObject*) _tmp62_, "location", _tmp63_, NULL);
	_tmp64_ = self->priv->tmp_full_path;
	g_debug ("Recorder.vala:122: The recording is temporary stored at %s", _tmp64_);
	_tmp65_ = gst_element_factory_make ("capsfilter", "filter");
	if (_tmp65_ != NULL) {
		g_object_ref_sink (_tmp65_);
	}
	caps_filter = _tmp65_;
	_tmp66_ = caps_filter;
	_tmp67_ = application_settings;
	_tmp68_ = gst_caps_new_simple ("audio/x-raw", "channels", G_TYPE_INT, (RecorderChannels) g_settings_get_enum (_tmp67_, "channels"), NULL);
	_tmp69_ = _tmp68_;
	g_object_set ((GObject*) _tmp66_, "caps", _tmp69_, NULL);
	_gst_caps_unref0 (_tmp69_);
	_tmp70_ = self->priv->pipeline;
	_tmp71_ = caps_filter;
	_tmp72_ = encoder;
	_tmp73_ = sink;
	gst_bin_add_many ((GstBin*) _tmp70_, _tmp71_, _tmp72_, _tmp73_, NULL);
	switch (source) {
		case RECORDER_SOURCE_MIC:
		{
			GstPipeline* _tmp74_;
			GstElement* _tmp75_;
			GstElement* _tmp76_;
			GstElement* _tmp77_;
			GstElement* _tmp78_;
			_tmp74_ = self->priv->pipeline;
			_tmp75_ = mic_sound;
			gst_bin_add_many ((GstBin*) _tmp74_, _tmp75_, NULL);
			_tmp76_ = mic_sound;
			_tmp77_ = caps_filter;
			_tmp78_ = encoder;
			gst_element_link_many (_tmp76_, _tmp77_, _tmp78_, NULL);
			break;
		}
		case RECORDER_SOURCE_SYSTEM:
		{
			GstPipeline* _tmp79_;
			GstElement* _tmp80_;
			GstElement* _tmp81_;
			GstElement* _tmp82_;
			GstElement* _tmp83_;
			_tmp79_ = self->priv->pipeline;
			_tmp80_ = sys_sound;
			gst_bin_add_many ((GstBin*) _tmp79_, _tmp80_, NULL);
			_tmp81_ = sys_sound;
			_tmp82_ = caps_filter;
			_tmp83_ = encoder;
			gst_element_link_many (_tmp81_, _tmp82_, _tmp83_, NULL);
			break;
		}
		case RECORDER_SOURCE_BOTH:
		{
			GstElement* mixer = NULL;
			GstElement* _tmp84_;
			GstPipeline* _tmp85_;
			GstElement* _tmp86_;
			GstElement* _tmp87_;
			GstElement* _tmp88_;
			GstElement* _tmp89_;
			GstPad* _tmp90_;
			GstPad* _tmp91_;
			GstElement* _tmp92_;
			GstPad* _tmp93_;
			GstPad* _tmp94_;
			GstElement* _tmp95_;
			GstPad* _tmp96_;
			GstPad* _tmp97_;
			GstElement* _tmp98_;
			GstPad* _tmp99_;
			GstPad* _tmp100_;
			GstElement* _tmp101_;
			GstElement* _tmp102_;
			GstElement* _tmp103_;
			_tmp84_ = gst_element_factory_make ("audiomixer", "mixer");
			if (_tmp84_ != NULL) {
				g_object_ref_sink (_tmp84_);
			}
			mixer = _tmp84_;
			_tmp85_ = self->priv->pipeline;
			_tmp86_ = mic_sound;
			_tmp87_ = sys_sound;
			_tmp88_ = mixer;
			gst_bin_add_many ((GstBin*) _tmp85_, _tmp86_, _tmp87_, _tmp88_, NULL);
			_tmp89_ = mic_sound;
			_tmp90_ = gst_element_get_static_pad (_tmp89_, "src");
			_tmp91_ = _tmp90_;
			_tmp92_ = mixer;
			_tmp93_ = gst_element_get_request_pad (_tmp92_, "sink_%u");
			_tmp94_ = _tmp93_;
			gst_pad_link_full (_tmp91_, _tmp94_, GST_PAD_LINK_CHECK_DEFAULT);
			_g_object_unref0 (_tmp94_);
			_g_object_unref0 (_tmp91_);
			_tmp95_ = sys_sound;
			_tmp96_ = gst_element_get_static_pad (_tmp95_, "src");
			_tmp97_ = _tmp96_;
			_tmp98_ = mixer;
			_tmp99_ = gst_element_get_request_pad (_tmp98_, "sink_%u");
			_tmp100_ = _tmp99_;
			gst_pad_link_full (_tmp97_, _tmp100_, GST_PAD_LINK_CHECK_DEFAULT);
			_g_object_unref0 (_tmp100_);
			_g_object_unref0 (_tmp97_);
			_tmp101_ = mixer;
			_tmp102_ = caps_filter;
			_tmp103_ = encoder;
			gst_element_link_many (_tmp101_, _tmp102_, _tmp103_, NULL);
			_g_object_unref0 (mixer);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp104_ = muxer;
	if (_tmp104_ != NULL) {
		GstPipeline* _tmp105_;
		GstElement* _tmp106_;
		GstElement* _tmp107_;
		GstPad* _tmp108_;
		GstPad* _tmp109_;
		GstElement* _tmp110_;
		GstPad* _tmp111_;
		GstPad* _tmp112_;
		GstElement* _tmp113_;
		GstElement* _tmp114_;
		_tmp105_ = self->priv->pipeline;
		_tmp106_ = muxer;
		gst_bin_add ((GstBin*) _tmp105_, _tmp106_);
		_tmp107_ = encoder;
		_tmp108_ = gst_element_get_static_pad (_tmp107_, "src");
		_tmp109_ = _tmp108_;
		_tmp110_ = muxer;
		_tmp111_ = gst_element_get_request_pad (_tmp110_, "audio_%u");
		_tmp112_ = _tmp111_;
		gst_pad_link_full (_tmp109_, _tmp112_, GST_PAD_LINK_CHECK_DEFAULT);
		_g_object_unref0 (_tmp112_);
		_g_object_unref0 (_tmp109_);
		_tmp113_ = muxer;
		_tmp114_ = sink;
		gst_element_link (_tmp113_, _tmp114_);
	} else {
		GstElement* _tmp115_;
		GstElement* _tmp116_;
		_tmp115_ = encoder;
		_tmp116_ = sink;
		gst_element_link (_tmp115_, _tmp116_);
	}
	_tmp117_ = self->priv->pipeline;
	_tmp118_ = gst_pipeline_get_bus (_tmp117_);
	_tmp119_ = _tmp118_;
	gst_bus_add_watch_full (_tmp119_, G_PRIORITY_DEFAULT, _recorder_bus_message_cb_gst_bus_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (_tmp119_);
	recorder_set_recording_state (self, GST_STATE_PLAYING);
	recorder_inhibit_sleep (self);
	_g_object_unref0 (caps_filter);
	_g_free0 (tmp_filename);
	_g_free0 (file_format);
	_g_object_unref0 (muxer);
	_g_object_unref0 (encoder);
	_g_object_unref0 (mic_sound);
	_g_object_unref0 (sys_sound);
	_g_object_unref0 (sink);
}

static gboolean
recorder_bus_message_cb (Recorder* self,
                         GstBus* bus,
                         GstMessage* msg)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (msg != NULL, FALSE);
	switch (msg->type) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			recorder_cancel_recording (self);
			gst_message_parse_error (msg, &_tmp0_, &_tmp1_);
			_g_error_free0 (err);
			err = _tmp0_;
			_g_free0 (debug);
			debug = _tmp1_;
			_tmp2_ = err;
			_tmp3_ = debug;
			g_signal_emit (self, recorder_signals[RECORDER_THROW_ERROR_SIGNAL], 0, _tmp2_, _tmp3_);
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_EOS:
		{
			GstPipeline* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			recorder_set_recording_state (self, GST_STATE_NULL);
			_tmp4_ = self->priv->pipeline;
			g_object_run_dispose ((GObject*) _tmp4_);
			_tmp5_ = self->priv->tmp_full_path;
			_tmp6_ = self->priv->suffix;
			g_signal_emit (self, recorder_signals[RECORDER_SAVE_FILE_SIGNAL], 0, _tmp5_, _tmp6_);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

void
recorder_cancel_recording (Recorder* self)
{
	GstPipeline* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	recorder_uninhibit_sleep (self);
	recorder_set_recording_state (self, GST_STATE_NULL);
	_tmp0_ = self->priv->pipeline;
	g_object_run_dispose ((GObject*) _tmp0_);
	{
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		_tmp1_ = self->priv->tmp_full_path;
		_tmp2_ = g_file_new_for_path (_tmp1_);
		_tmp3_ = _tmp2_;
		g_file_delete (_tmp3_, NULL, &_inner_error0_);
		_g_object_unref0 (_tmp3_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("Recorder.vala:198: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
recorder_stop_recording (Recorder* self)
{
	GstPipeline* _tmp0_;
	GstEvent* _tmp1_;
	g_return_if_fail (self != NULL);
	recorder_uninhibit_sleep (self);
	_tmp0_ = self->priv->pipeline;
	_tmp1_ = gst_event_new_eos ();
	gst_element_send_event ((GstElement*) _tmp0_, _tmp1_);
}

void
recorder_set_recording_state (Recorder* self,
                              GstState state)
{
	GstPipeline* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp0_, state);
	switch (state) {
		case GST_STATE_PLAYING:
		{
			recorder_set_is_recording (self, TRUE);
			break;
		}
		case GST_STATE_PAUSED:
		case GST_STATE_NULL:
		{
			recorder_set_is_recording (self, FALSE);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static void
recorder_inhibit_sleep (Recorder* self)
{
	GtkApplication* app = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp2_;
	GtkApplication* _tmp3_;
	GtkWindow* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_application_get_default ();
	app = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication);
	if (self->priv->inhibit_token != ((guint) 0)) {
		GtkApplication* _tmp1_;
		_tmp1_ = app;
		gtk_application_uninhibit (_tmp1_, self->priv->inhibit_token);
	}
	_tmp2_ = app;
	_tmp3_ = app;
	_tmp4_ = gtk_application_get_active_window (_tmp3_);
	self->priv->inhibit_token = gtk_application_inhibit (_tmp2_, _tmp4_, GTK_APPLICATION_INHIBIT_IDLE | GTK_APPLICATION_INHIBIT_SUSPEND, _ ("Recording is ongoing"));
}

static void
recorder_uninhibit_sleep (Recorder* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->inhibit_token != ((guint) 0)) {
		GApplication* _tmp0_;
		_tmp0_ = g_application_get_default ();
		gtk_application_uninhibit (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication), self->priv->inhibit_token);
		self->priv->inhibit_token = (guint) 0;
	}
}

gboolean
recorder_get_is_recording (Recorder* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_recording;
	return result;
}

static void
recorder_set_is_recording (Recorder* self,
                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = recorder_get_is_recording (self);
	if (old_value != value) {
		self->priv->_is_recording = value;
		g_object_notify_by_pspec ((GObject *) self, recorder_properties[RECORDER_IS_RECORDING_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__BOXED_STRING (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
recorder_class_init (RecorderClass * klass,
                     gpointer klass_data)
{
	recorder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Recorder_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_recorder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_recorder_set_property;
	G_OBJECT_CLASS (klass)->finalize = recorder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RECORDER_IS_RECORDING_PROPERTY, recorder_properties[RECORDER_IS_RECORDING_PROPERTY] = g_param_spec_boolean ("is-recording", "is-recording", "is-recording", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	recorder_signals[RECORDER_THROW_ERROR_SIGNAL] = g_signal_new ("throw-error", TYPE_RECORDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_STRING, G_TYPE_NONE, 2, G_TYPE_ERROR, G_TYPE_STRING);
	recorder_signals[RECORDER_SAVE_FILE_SIGNAL] = g_signal_new ("save-file", TYPE_RECORDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static void
recorder_instance_init (Recorder * self,
                        gpointer klass)
{
	self->priv = recorder_get_instance_private (self);
	self->priv->inhibit_token = (guint) 0;
}

static void
recorder_finalize (GObject * obj)
{
	Recorder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RECORDER, Recorder);
	_g_object_unref0 (self->priv->pam);
	_g_free0 (self->priv->suffix);
	_g_free0 (self->priv->tmp_full_path);
	_g_object_unref0 (self->priv->pipeline);
	G_OBJECT_CLASS (recorder_parent_class)->finalize (obj);
}

static GType
recorder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RecorderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) recorder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Recorder), 0, (GInstanceInitFunc) recorder_instance_init, NULL };
	GType recorder_type_id;
	recorder_type_id = g_type_register_static (G_TYPE_OBJECT, "Recorder", &g_define_type_info, 0);
	Recorder_private_offset = g_type_add_instance_private (recorder_type_id, sizeof (RecorderPrivate));
	return recorder_type_id;
}

GType
recorder_get_type (void)
{
	static volatile gsize recorder_type_id__once = 0;
	if (g_once_init_enter (&recorder_type_id__once)) {
		GType recorder_type_id;
		recorder_type_id = recorder_get_type_once ();
		g_once_init_leave (&recorder_type_id__once, recorder_type_id);
	}
	return recorder_type_id__once;
}

static void
_vala_recorder_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	Recorder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RECORDER, Recorder);
	switch (property_id) {
		case RECORDER_IS_RECORDING_PROPERTY:
		g_value_set_boolean (value, recorder_get_is_recording (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_recorder_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	Recorder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RECORDER, Recorder);
	switch (property_id) {
		case RECORDER_IS_RECORDING_PROPERTY:
		recorder_set_is_recording (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

