/* RecordView.c generated by valac 0.56.17, the Vala compiler
 * generated from RecordView.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018-2021 Ryo Nakano <ryonakaknock3@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <glib.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_RECORD_VIEW (record_view_get_type ())
#define RECORD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RECORD_VIEW, RecordView))
#define RECORD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RECORD_VIEW, RecordViewClass))
#define IS_RECORD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RECORD_VIEW))
#define IS_RECORD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RECORD_VIEW))
#define RECORD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RECORD_VIEW, RecordViewClass))

typedef struct _RecordView RecordView;
typedef struct _RecordViewClass RecordViewClass;
typedef struct _RecordViewPrivate RecordViewPrivate;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

#define TYPE_RECORDER (recorder_get_type ())
#define RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RECORDER, Recorder))
#define RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RECORDER, RecorderClass))
#define IS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RECORDER))
#define IS_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RECORDER))
#define RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RECORDER, RecorderClass))

typedef struct _Recorder Recorder;
typedef struct _RecorderClass RecorderClass;
enum  {
	RECORD_VIEW_0_PROPERTY,
	RECORD_VIEW_WINDOW_PROPERTY,
	RECORD_VIEW_NUM_PROPERTIES
};
static GParamSpec* record_view_properties[RECORD_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _RecordViewTriggerStopRecordingData RecordViewTriggerStopRecordingData;
typedef struct _Block2Data Block2Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

struct _RecordView {
	GtkBox parent_instance;
	RecordViewPrivate * priv;
};

struct _RecordViewClass {
	GtkBoxClass parent_class;
};

struct _RecordViewPrivate {
	MainWindow* _window;
	Recorder* recorder;
	GtkLabel* time_label;
	GtkLabel* remaining_time_label;
	GtkButton* stop_button;
	GtkButton* pause_button;
	guint count;
	guint countdown;
	guint past_minutes_10;
	guint past_minutes_1;
	guint past_seconds_10;
	guint past_seconds_1;
	guint remain_minutes_10;
	guint remain_minutes_1;
	guint remain_seconds_10;
	guint remain_seconds_1;
};

struct _RecordViewTriggerStopRecordingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RecordView* self;
	Recorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Recorder* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	Recorder* _tmp8_;
	MainWindow* _tmp9_;
};

struct _Block2Data {
	int _ref_count_;
	RecordView* self;
	GMainLoop* loop;
};

struct _Block3Data {
	int _ref_count_;
	RecordView* self;
	GMainLoop* loop;
};

static gint RecordView_private_offset;
static gpointer record_view_parent_class = NULL;
VALA_EXTERN GSettings* application_settings;

VALA_EXTERN GType record_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RecordView, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN GType recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Recorder, g_object_unref)
VALA_EXTERN RecordView* record_view_new (MainWindow* window);
VALA_EXTERN RecordView* record_view_construct (GType object_type,
                                   MainWindow* window);
static void record_view_trigger_stop_recording_data_free (gpointer _data);
VALA_EXTERN void record_view_trigger_stop_recording (RecordView* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void record_view_trigger_stop_recording_finish (RecordView* self,
                                                GAsyncResult* _res_);
static gboolean record_view_trigger_stop_recording_co (RecordViewTriggerStopRecordingData* _data_);
VALA_EXTERN void record_view_stop_count (RecordView* self);
VALA_EXTERN gboolean recorder_get_is_recording (Recorder* self);
VALA_EXTERN void recorder_set_recording_state (Recorder* self,
                                   GstState state);
VALA_EXTERN void recorder_stop_recording (Recorder* self);
VALA_EXTERN MainWindow* record_view_get_window (RecordView* self);
VALA_EXTERN void main_window_show_welcome (MainWindow* self);
VALA_EXTERN void record_view_init_count (RecordView* self);
static void record_view_show_timer_label (RecordView* self,
                                   GtkLabel* label,
                                   guint minutes_10,
                                   guint minutes_1,
                                   guint seconds_10,
                                   guint seconds_1);
static void record_view_start_count (RecordView* self);
static gboolean __lambda7_ (RecordView* self);
static gboolean ___lambda7__gsource_func (gpointer self);
VALA_EXTERN void record_view_init_countdown (RecordView* self,
                                 guint remaining_time);
static void record_view_start_countdown (RecordView* self);
static gboolean __lambda8_ (RecordView* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ___lambda9_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda9__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean ___lambda8__gsource_func (gpointer self);
static void record_view_set_window (RecordView* self,
                             MainWindow* value);
static GObject * record_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN Recorder* recorder_get_default (void);
static void _record_view___lambda10_ (RecordView* self);
VALA_EXTERN void recorder_cancel_recording (Recorder* self);
static void __record_view___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void _record_view___lambda11_ (RecordView* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda12_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __record_view___lambda11__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void _record_view___lambda13_ (RecordView* self);
static void __record_view___lambda13__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void record_view_finalize (GObject * obj);
static GType record_view_get_type_once (void);
static void _vala_record_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_record_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
record_view_get_instance_private (RecordView* self)
{
	return G_STRUCT_MEMBER_P (self, RecordView_private_offset);
}

RecordView*
record_view_construct (GType object_type,
                       MainWindow* window)
{
	RecordView * self = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (RecordView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 12, "window", window, "margin", 6, NULL);
	return self;
}

RecordView*
record_view_new (MainWindow* window)
{
	return record_view_construct (TYPE_RECORD_VIEW, window);
}

static void
record_view_trigger_stop_recording_data_free (gpointer _data)
{
	RecordViewTriggerStopRecordingData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (RecordViewTriggerStopRecordingData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
record_view_trigger_stop_recording (RecordView* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	RecordViewTriggerStopRecordingData* _data_;
	RecordView* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (RecordViewTriggerStopRecordingData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, record_view_trigger_stop_recording_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	record_view_trigger_stop_recording_co (_data_);
}

void
record_view_trigger_stop_recording_finish (RecordView* self,
                                           GAsyncResult* _res_)
{
	RecordViewTriggerStopRecordingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
record_view_trigger_stop_recording_co (RecordViewTriggerStopRecordingData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	record_view_stop_count (_data_->self);
	_data_->_tmp0_ = _data_->self->priv->recorder;
	_data_->_tmp1_ = recorder_get_is_recording (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (!_data_->_tmp2_) {
		_data_->_tmp3_ = _data_->self->priv->recorder;
		recorder_set_recording_state (_data_->_tmp3_, GST_STATE_PLAYING);
		_data_->_tmp4_ = _data_->self->priv->pause_button;
		_data_->_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
		g_object_ref_sink (_data_->_tmp5_);
		_data_->_tmp6_ = _data_->_tmp5_;
		gtk_button_set_image (_data_->_tmp4_, (GtkWidget*) _data_->_tmp6_);
		_g_object_unref0 (_data_->_tmp6_);
		_data_->_tmp7_ = _data_->self->priv->pause_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _data_->_tmp7_, _ ("Pause recording"));
	}
	_data_->_tmp8_ = _data_->self->priv->recorder;
	recorder_stop_recording (_data_->_tmp8_);
	_data_->_tmp9_ = _data_->self->priv->_window;
	main_window_show_welcome (_data_->_tmp9_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
record_view_init_count (RecordView* self)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->past_minutes_10 = (guint) 0;
	self->priv->past_minutes_1 = (guint) 0;
	self->priv->past_seconds_10 = (guint) 0;
	self->priv->past_seconds_1 = (guint) 0;
	_tmp0_ = self->priv->time_label;
	record_view_show_timer_label (self, _tmp0_, self->priv->past_minutes_10, self->priv->past_minutes_1, self->priv->past_seconds_10, self->priv->past_seconds_1);
	record_view_start_count (self);
}

static gboolean
__lambda7_ (RecordView* self)
{
	Recorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkLabel* _tmp12_;
	gboolean result;
	_tmp0_ = self->priv->recorder;
	_tmp1_ = recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		result = FALSE;
		return result;
	}
	if (self->priv->past_seconds_10 < ((guint) 5)) {
		_tmp3_ = self->priv->past_seconds_1 == ((guint) 9);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		guint _tmp4_;
		_tmp4_ = self->priv->past_seconds_10;
		self->priv->past_seconds_10 = _tmp4_ + 1;
		self->priv->past_seconds_1 = (guint) 0;
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		if (self->priv->past_minutes_1 < ((guint) 9)) {
			_tmp6_ = self->priv->past_seconds_10 == ((guint) 5);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			_tmp5_ = self->priv->past_seconds_1 == ((guint) 9);
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			guint _tmp7_;
			_tmp7_ = self->priv->past_minutes_1;
			self->priv->past_minutes_1 = _tmp7_ + 1;
			self->priv->past_seconds_10 = (guint) 0;
			self->priv->past_seconds_1 = self->priv->past_seconds_10;
		} else {
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			if (self->priv->past_minutes_1 == ((guint) 9)) {
				_tmp9_ = self->priv->past_seconds_10 == ((guint) 5);
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				_tmp8_ = self->priv->past_seconds_1 == ((guint) 9);
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				guint _tmp10_;
				_tmp10_ = self->priv->past_minutes_10;
				self->priv->past_minutes_10 = _tmp10_ + 1;
				self->priv->past_seconds_1 = (guint) 0;
				self->priv->past_seconds_10 = self->priv->past_seconds_1;
				self->priv->past_minutes_1 = self->priv->past_seconds_10;
			} else {
				guint _tmp11_;
				_tmp11_ = self->priv->past_seconds_1;
				self->priv->past_seconds_1 = _tmp11_ + 1;
			}
		}
	}
	_tmp12_ = self->priv->time_label;
	record_view_show_timer_label (self, _tmp12_, self->priv->past_minutes_10, self->priv->past_minutes_1, self->priv->past_seconds_10, self->priv->past_seconds_1);
	result = TRUE;
	return result;
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ ((RecordView*) self);
	return result;
}

static void
record_view_start_count (RecordView* self)
{
	g_return_if_fail (self != NULL);
	self->priv->count = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda7__gsource_func, g_object_ref (self), g_object_unref);
}

void
record_view_stop_count (RecordView* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->count != ((guint) 0)) {
		self->priv->count = (guint) 0;
	}
	if (self->priv->countdown != ((guint) 0)) {
		self->priv->countdown = (guint) 0;
	}
}

void
record_view_init_countdown (RecordView* self,
                            guint remaining_time)
{
	guint remain_minutes = 0U;
	guint remain_seconds = 0U;
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	remain_minutes = remaining_time / 60;
	if (remain_minutes < ((guint) 10)) {
		self->priv->remain_minutes_10 = (guint) 0;
		self->priv->remain_minutes_1 = remain_minutes;
	} else {
		self->priv->remain_minutes_10 = remain_minutes / 10;
		self->priv->remain_minutes_1 = remain_minutes % 10;
	}
	remain_seconds = remaining_time % 60;
	if (remain_seconds < ((guint) 10)) {
		self->priv->remain_seconds_10 = (guint) 0;
		self->priv->remain_seconds_1 = remain_seconds;
	} else {
		self->priv->remain_seconds_10 = remain_seconds / 10;
		self->priv->remain_seconds_1 = remain_seconds % 10;
	}
	_tmp0_ = self->priv->time_label;
	record_view_show_timer_label (self, _tmp0_, self->priv->past_minutes_10, self->priv->past_minutes_1, self->priv->past_seconds_10, self->priv->past_seconds_1);
	record_view_start_countdown (self);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		RecordView* self;
		self = _data2_->self;
		_g_main_loop_unref0 (_data2_->loop);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
___lambda9_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* res)
{
	RecordView* self;
	GMainLoop* _tmp0_;
	self = _data2_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = _data2_->loop;
	g_main_loop_quit (_tmp0_);
}

static void
____lambda9__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	___lambda9_ (self, source_object, res);
	block2_data_unref (self);
}

static gboolean
__lambda8_ (RecordView* self)
{
	Recorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GtkLabel* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean result;
	_tmp0_ = self->priv->recorder;
	_tmp1_ = recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		result = FALSE;
		return result;
	}
	if (self->priv->remain_minutes_1 == ((guint) 0)) {
		_tmp4_ = self->priv->remain_seconds_10 == ((guint) 0);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_tmp3_ = self->priv->remain_seconds_1 == ((guint) 0);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		guint _tmp5_;
		_tmp5_ = self->priv->remain_minutes_10;
		self->priv->remain_minutes_10 = _tmp5_ - 1;
		self->priv->remain_seconds_1 = (guint) 9;
		self->priv->remain_minutes_1 = self->priv->remain_seconds_1;
		self->priv->remain_seconds_10 = (guint) 5;
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		if (self->priv->remain_minutes_1 > ((guint) 0)) {
			_tmp7_ = self->priv->remain_seconds_10 == ((guint) 0);
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			_tmp6_ = self->priv->remain_seconds_1 == ((guint) 0);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			guint _tmp8_;
			_tmp8_ = self->priv->remain_minutes_1;
			self->priv->remain_minutes_1 = _tmp8_ - 1;
			self->priv->remain_seconds_10 = (guint) 5;
			self->priv->remain_seconds_1 = (guint) 9;
		} else {
			gboolean _tmp9_ = FALSE;
			if (self->priv->remain_seconds_10 > ((guint) 0)) {
				_tmp9_ = self->priv->remain_seconds_1 == ((guint) 0);
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				guint _tmp10_;
				_tmp10_ = self->priv->remain_seconds_10;
				self->priv->remain_seconds_10 = _tmp10_ - 1;
				self->priv->remain_seconds_1 = (guint) 9;
			} else {
				guint _tmp11_;
				_tmp11_ = self->priv->remain_seconds_1;
				self->priv->remain_seconds_1 = _tmp11_ - 1;
			}
		}
	}
	_tmp12_ = self->priv->remaining_time_label;
	record_view_show_timer_label (self, _tmp12_, self->priv->remain_minutes_10, self->priv->remain_minutes_1, self->priv->remain_seconds_10, self->priv->remain_seconds_1);
	if (self->priv->remain_minutes_10 == ((guint) 0)) {
		_tmp15_ = self->priv->remain_minutes_1 == ((guint) 0);
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		_tmp14_ = self->priv->remain_seconds_10 == ((guint) 0);
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		_tmp13_ = self->priv->remain_seconds_1 == ((guint) 0);
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		Block2Data* _data2_;
		GMainLoop* _tmp16_;
		GMainLoop* _tmp17_;
		_data2_ = g_slice_new0 (Block2Data);
		_data2_->_ref_count_ = 1;
		_data2_->self = g_object_ref (self);
		_tmp16_ = g_main_loop_new (NULL, FALSE);
		_data2_->loop = _tmp16_;
		record_view_trigger_stop_recording (self, ____lambda9__gasync_ready_callback, block2_data_ref (_data2_));
		_tmp17_ = _data2_->loop;
		g_main_loop_run (_tmp17_);
		result = FALSE;
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	result = TRUE;
	return result;
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ ((RecordView*) self);
	return result;
}

static void
record_view_start_countdown (RecordView* self)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remaining_time_label;
	record_view_show_timer_label (self, _tmp0_, self->priv->remain_minutes_10, self->priv->remain_minutes_1, self->priv->remain_seconds_10, self->priv->remain_seconds_1);
	self->priv->countdown = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
}

static void
record_view_show_timer_label (RecordView* self,
                              GtkLabel* label,
                              guint minutes_10,
                              guint minutes_1,
                              guint seconds_10,
                              guint seconds_1)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = g_strdup_printf ("%ld%ld:%ld%ld", (glong) minutes_10, (glong) minutes_1, (glong) seconds_10, (glong) seconds_1);
	_tmp1_ = _tmp0_;
	gtk_label_set_label (label, _tmp1_);
	_g_free0 (_tmp1_);
}

MainWindow*
record_view_get_window (RecordView* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
record_view_set_window (RecordView* self,
                        MainWindow* value)
{
	MainWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = record_view_get_window (self);
	if (old_value != value) {
		MainWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, record_view_properties[RECORD_VIEW_WINDOW_PROPERTY]);
	}
}

static void
_record_view___lambda10_ (RecordView* self)
{
	Recorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Recorder* _tmp7_;
	MainWindow* _tmp8_;
	record_view_stop_count (self);
	_tmp0_ = self->priv->recorder;
	_tmp1_ = recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GtkButton* _tmp3_;
		GtkImage* _tmp4_;
		GtkImage* _tmp5_;
		GtkButton* _tmp6_;
		_tmp3_ = self->priv->pause_button;
		_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
		g_object_ref_sink (_tmp4_);
		_tmp5_ = _tmp4_;
		gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp5_);
		_g_object_unref0 (_tmp5_);
		_tmp6_ = self->priv->pause_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Pause recording"));
	}
	_tmp7_ = self->priv->recorder;
	recorder_cancel_recording (_tmp7_);
	_tmp8_ = self->priv->_window;
	main_window_show_welcome (_tmp8_);
}

static void
__record_view___lambda10__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	_record_view___lambda10_ ((RecordView*) self);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		RecordView* self;
		self = _data3_->self;
		_g_main_loop_unref0 (_data3_->loop);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda12_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	RecordView* self;
	GMainLoop* _tmp0_;
	self = _data3_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = _data3_->loop;
	g_main_loop_quit (_tmp0_);
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda12_ (self, source_object, res);
	block3_data_unref (self);
}

static void
_record_view___lambda11_ (RecordView* self)
{
	Block3Data* _data3_;
	GMainLoop* _tmp0_;
	GMainLoop* _tmp1_;
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = g_main_loop_new (NULL, FALSE);
	_data3_->loop = _tmp0_;
	record_view_trigger_stop_recording (self, ___lambda12__gasync_ready_callback, block3_data_ref (_data3_));
	_tmp1_ = _data3_->loop;
	g_main_loop_run (_tmp1_);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static void
__record_view___lambda11__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	_record_view___lambda11_ ((RecordView*) self);
}

static void
_record_view___lambda13_ (RecordView* self)
{
	Recorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->recorder;
	_tmp1_ = recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		Recorder* _tmp3_;
		GtkButton* _tmp4_;
		GtkImage* _tmp5_;
		GtkImage* _tmp6_;
		GtkButton* _tmp7_;
		record_view_stop_count (self);
		_tmp3_ = self->priv->recorder;
		recorder_set_recording_state (_tmp3_, GST_STATE_PAUSED);
		_tmp4_ = self->priv->pause_button;
		_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
		g_object_ref_sink (_tmp5_);
		_tmp6_ = _tmp5_;
		gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
		_g_object_unref0 (_tmp6_);
		_tmp7_ = self->priv->pause_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Resume recording"));
	} else {
		GSettings* _tmp8_;
		Recorder* _tmp9_;
		GtkButton* _tmp10_;
		GtkImage* _tmp11_;
		GtkImage* _tmp12_;
		GtkButton* _tmp13_;
		record_view_start_count (self);
		_tmp8_ = application_settings;
		if (g_settings_get_uint (_tmp8_, "length") != ((guint) 0)) {
			record_view_start_countdown (self);
		}
		_tmp9_ = self->priv->recorder;
		recorder_set_recording_state (_tmp9_, GST_STATE_PLAYING);
		_tmp10_ = self->priv->pause_button;
		_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
		g_object_ref_sink (_tmp11_);
		_tmp12_ = _tmp11_;
		gtk_button_set_image (_tmp10_, (GtkWidget*) _tmp12_);
		_g_object_unref0 (_tmp12_);
		_tmp13_ = self->priv->pause_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Pause recording"));
	}
}

static void
__record_view___lambda13__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	_record_view___lambda13_ ((RecordView*) self);
}

static GObject *
record_view_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	RecordView * self;
	Recorder* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkGrid* label_grid = NULL;
	GtkGrid* _tmp7_ = NULL;
	GtkGrid* _tmp8_;
	GtkLabel* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkButton* cancel_button = NULL;
	GtkImage* _tmp12_;
	gchar* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkImage* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	GtkButton* _tmp22_ = NULL;
	GtkButton* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkImage* _tmp25_;
	gchar* _tmp26_;
	GtkButton* _tmp27_ = NULL;
	GtkButton* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkGrid* buttons_grid = NULL;
	GtkGrid* _tmp30_ = NULL;
	GtkGrid* _tmp31_;
	GtkButton* _tmp32_;
	GtkGrid* _tmp33_;
	GtkButton* _tmp34_;
	GtkGrid* _tmp35_;
	GtkButton* _tmp36_;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	parent_class = G_OBJECT_CLASS (record_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RECORD_VIEW, RecordView);
	_tmp0_ = recorder_get_default ();
	_g_object_unref0 (self->priv->recorder);
	self->priv->recorder = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp1_;
	_tmp2_ = self->priv->time_label;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->remaining_time_label);
	self->priv->remaining_time_label = _tmp4_;
	_tmp5_ = self->priv->remaining_time_label;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp7_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp7_, 6);
	gtk_grid_set_row_spacing (_tmp7_, 6);
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp7_);
	label_grid = _tmp7_;
	_tmp8_ = label_grid;
	_tmp9_ = self->priv->time_label;
	gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, 0, 1, 1, 1);
	_tmp10_ = label_grid;
	_tmp11_ = self->priv->remaining_time_label;
	gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 0, 2, 1, 1);
	_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp12_);
	_tmp13_ = g_strdup (_ ("Cancel recording"));
	_tmp14_ = (GtkButton*) gtk_button_new ();
	gtk_button_set_image (_tmp14_, (GtkWidget*) _tmp12_);
	_g_object_unref0 (_tmp12_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp13_);
	_g_free0 (_tmp13_);
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp14_);
	cancel_button = _tmp14_;
	_tmp15_ = cancel_button;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_add_class (_tmp16_, "buttons-without-border");
	_tmp17_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp17_);
	_tmp18_ = g_strdup ("<Shift><Ctrl>R");
	_tmp19_ = g_new0 (gchar*, 1 + 1);
	_tmp19_[0] = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp20__length1 = 1;
	_tmp21_ = granite_markup_accel_tooltip (_tmp20_, (gint) 1, _ ("Finish recording"));
	_tmp22_ = (GtkButton*) gtk_button_new ();
	gtk_button_set_image (_tmp22_, (GtkWidget*) _tmp17_);
	_g_object_unref0 (_tmp17_);
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp22_, _tmp21_);
	_g_free0 (_tmp21_);
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
	g_object_set ((GtkWidget*) _tmp22_, "width-request", 48, NULL);
	g_object_set ((GtkWidget*) _tmp22_, "height-request", 48, NULL);
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->stop_button);
	self->priv->stop_button = _tmp22_;
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
	_tmp23_ = self->priv->stop_button;
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
	gtk_style_context_add_class (_tmp24_, "record-button");
	_tmp25_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp25_);
	_tmp26_ = g_strdup (_ ("Pause recording"));
	_tmp27_ = (GtkButton*) gtk_button_new ();
	gtk_button_set_image (_tmp27_, (GtkWidget*) _tmp25_);
	_g_object_unref0 (_tmp25_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _tmp26_);
	_g_free0 (_tmp26_);
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->pause_button);
	self->priv->pause_button = _tmp27_;
	_tmp28_ = self->priv->pause_button;
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
	gtk_style_context_add_class (_tmp29_, "buttons-without-border");
	_tmp30_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp30_, 30);
	gtk_grid_set_row_spacing (_tmp30_, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp30_, 12);
	gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp30_);
	buttons_grid = _tmp30_;
	_tmp31_ = buttons_grid;
	_tmp32_ = cancel_button;
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 0, 1, 1);
	_tmp33_ = buttons_grid;
	_tmp34_ = self->priv->stop_button;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 1, 0, 1, 1);
	_tmp35_ = buttons_grid;
	_tmp36_ = self->priv->pause_button;
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 2, 0, 1, 1);
	_tmp37_ = label_grid;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp37_, FALSE, FALSE, (guint) 0);
	_tmp38_ = buttons_grid;
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp38_, FALSE, FALSE, (guint) 0);
	_tmp39_ = cancel_button;
	g_signal_connect_object (_tmp39_, "clicked", (GCallback) __record_view___lambda10__gtk_button_clicked, self, 0);
	_tmp40_ = self->priv->stop_button;
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) __record_view___lambda11__gtk_button_clicked, self, 0);
	_tmp41_ = self->priv->pause_button;
	g_signal_connect_object (_tmp41_, "clicked", (GCallback) __record_view___lambda13__gtk_button_clicked, self, 0);
	_g_object_unref0 (buttons_grid);
	_g_object_unref0 (cancel_button);
	_g_object_unref0 (label_grid);
	return obj;
}

static void
record_view_class_init (RecordViewClass * klass,
                        gpointer klass_data)
{
	record_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &RecordView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_record_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_record_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = record_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = record_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RECORD_VIEW_WINDOW_PROPERTY, record_view_properties[RECORD_VIEW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
record_view_instance_init (RecordView * self,
                           gpointer klass)
{
	self->priv = record_view_get_instance_private (self);
}

static void
record_view_finalize (GObject * obj)
{
	RecordView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RECORD_VIEW, RecordView);
	_g_object_unref0 (self->priv->_window);
	_g_object_unref0 (self->priv->recorder);
	_g_object_unref0 (self->priv->time_label);
	_g_object_unref0 (self->priv->remaining_time_label);
	_g_object_unref0 (self->priv->stop_button);
	_g_object_unref0 (self->priv->pause_button);
	G_OBJECT_CLASS (record_view_parent_class)->finalize (obj);
}

static GType
record_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RecordViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) record_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RecordView), 0, (GInstanceInitFunc) record_view_instance_init, NULL };
	GType record_view_type_id;
	record_view_type_id = g_type_register_static (gtk_box_get_type (), "RecordView", &g_define_type_info, 0);
	RecordView_private_offset = g_type_add_instance_private (record_view_type_id, sizeof (RecordViewPrivate));
	return record_view_type_id;
}

GType
record_view_get_type (void)
{
	static volatile gsize record_view_type_id__once = 0;
	if (g_once_init_enter (&record_view_type_id__once)) {
		GType record_view_type_id;
		record_view_type_id = record_view_get_type_once ();
		g_once_init_leave (&record_view_type_id__once, record_view_type_id);
	}
	return record_view_type_id__once;
}

static void
_vala_record_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	RecordView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RECORD_VIEW, RecordView);
	switch (property_id) {
		case RECORD_VIEW_WINDOW_PROPERTY:
		g_value_set_object (value, record_view_get_window (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_record_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	RecordView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RECORD_VIEW, RecordView);
	switch (property_id) {
		case RECORD_VIEW_WINDOW_PROPERTY:
		record_view_set_window (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

